﻿
'
'/**
'--------------------------------------------------
' Versión .....: 2011-12-04 11:37:47   
'               [aaaa-mm-dd] 
' Original en .: util
'--------------------------------------------------
'
'
' -------------------------------------------------
' CONTROL ..: TextBoxAutoElipsis
' Lenguaje .: (.NET Framework 4.0.30319.239) - Microsoft Visual Basic .NET 2010 - [2011]
' Usuario ..: Aguila764 - Joaqui
' Autor ....: Joaquin 'jms32' Medina Serrano
' Emilio ...: mailto:joaquin@medina.name
' Web ......: http://joaquin.medina.name
' -------------------------------------------------
'
' DESCRIPCION.:
'    Control [TextBox] con la propiedad [AutoElipsis] incluida
'
' OBSERVACIONES.:
'   
'
' INTERFAZ.:
'------------------
' PROPIEDADES
'Public Property TextFormatFlags() As Windows.Forms.TextFormatFlags
'    Especifica la información de diseño y de presentación de las cadenas 
'    de texto, se recomienda usar el valor [WordEllipsis]")
'
' Public Property AutoElipsis() As Boolean
'    Obtiene o establece un valor que indica si el carácter de puntos suspensivos (...)
'    aparece en el borde derecho del [TexBox], lo que indica que el texto
'    se entiende más allá del espacio visible del control [TexBox]
'
' Public Overrides Property Text() As String
'   Obtiene o establece el texto actual del TextBox.
'   Si la propiedad [AutoElipsis=True] quiere decir que en el cuadro de texto hay 
'   al final puntos suspensivos, con lo que sí quiero recuperar la información 
'   del cuadro de texto tengo que recuperar la información de la variable [_cadenaDelTextBox] 
'   que es la que guarda esa información, si la propiedad no está 
'   activa [AutoElipsis=False] se devuelve directamente el valor de la propiedad [Text]
'
'------------------
' EVENTOS
' Me.GotFocus '  Guarda el valor de la propiedad [Text], para poder recuperar el valor original introducido
' LostFocus   '  Al abandonar el control se guarda el valor y se muestra el valor formateado
' MouseHover  '  Se muestra (en un ToolTip) todo el contenido del TextBox al pasar el cursor por encima
' MouseLeave  '  Se borra el  ToolTip
'
'------------------
' FUNCION INTERNA
' Private Shared Function CompactString
'   Trunca una cadena de texto añadiendo el carácter puntos suspensivos (...), 
'   si el tamaño de la cadena de texto excede el tamaño máximo permitido
'------------------
'
' BIBLIOGRAFIA.:
'   http://www.codeproject.com/KB/vb/NewPathCompactPath.aspx 
'   http://msdn.microsoft.com/es-es/library/system.windows.forms.textformatflags.aspx 
'   http://msdn.microsoft.com/es-es/library/7sy6awsb.aspx 
'   http://msdn.microsoft.com/es-es/library/system.windows.forms.label.autoellipsis.aspx 
'
' HERENCIA.:
'    [TextBox]
'
' MODIFICACIONES  [aaaa-mm-dd] 
' - 2011-12-04 11:37:47 - Creación 
' - 2011-12-04 - Revisado con FxCop
' - 2011/--/-- - ???
'
' -------------------------------------------------
'
'*/
'
'
' -------------------------------------------------
Option Explicit On
Option Strict On
Option Infer Off
Option Compare Binary


Imports System.ComponentModel

''' <summary>
''' Control [TextBox] con la propiedad [AutoElipsis] incluida
''' </summary>
''' <remarks></remarks>
Public Class TextBoxAutoElipsis
    Inherits TextBox

#Region "Autoelipsis"

#Region "Funcion que hace el trabajo de poner los puntos suspensivos"


    '---------------------    
    '---------------------
    ' Texto Inicial
    ' E:\Fotos\Wallpaper\Fotitos\pocholas\2011-10-23_250_Arthur´s & Lewis passes.JPG
    '---------------------
    ' Default  Aplica el formato predeterminado: la alineación a la izquierda.
    '    Resultado E:\Fotos\Wallpaper\Fotitos\pocholas\2011-10-23_250_Arthur´s & Lewis passes.JPG

    ' EndEllipsis ' pone los puntos al final de la cadena
    '    Resultado E:\Fotos\Wallpaper\Fotitos\pocholas\2011-10-23_250_Arthur´s & Lew...
    ' PathEllipsis  Quita el centro de las líneas recortadas y lo reemplaza con puntos suspensivos. 
    '    Resultado E:\Fotos\Wallpaper\Fo...\2011-10-23_250_Arthur´s & Lewis passes.JPG
    ' WordEllipsis Recorta la línea hasta la palabra más cercana y coloca puntos suspensivos al final de una línea recortada.
    '    Resultado E:\Fotos\Wallpaper\Fotitos\pocholas\2011-10-23_250_Arthur´s & Lew...
    '---------------------
    '---------------------
    ' Texto Inicial
    '    En un lugar de la mancha de cuyo nobre no quiero acordarme, no ha mucho que habia
    '---------------------
    ' EndEllipsis 
    ' En un lugar de la mancha de cuyo nobre no quiero acordarme, no ha ...
    ' PathEllipsis  
    ' No hace nada,
    'En un lugar de la mancha de cuyo nobre no quiero acordarme, no ha mucho que habia
    ' WordEllipsis
    ' En un lugar de la mancha de cuyo nobre no quiero acordarme, no ha ...



    '---------------------------------------------------------------
    ' Esta es la función que realmente hace el trabajo de de poner los puntos suspensivos al texto
    '---------------------------------------------------------------
    ''' <summary>
    '''   Trunca una cadena de texto añadiendo el carácter puntos suspensivos (...), 
    '''   si el tamaño de la cadena de texto excede el tamaño máximo permitido
    ''' </summary>
    ''' <param name="cadenaOriginal">
    '''    <para> Tipo:<see cref="System.String">String</see>    </para>
    '''    <para> La cadena que se va a tratar</para>
    ''' </param> 
    ''' <param name="anchuraMaxima">
    '''    <para> Tipo:<see cref="System.Integer">Integer</see>    </para>
    '''    <para> Ancho del control, en píxeles. </para>
    '''    <para> La anchura maxima que puede tener la cadena (en píxeles) </para>
    ''' </param>
    ''' <param name="fuenteDelTexto"> 
    '''    <para> Tipo.: <see cref="System.Drawing.Font">Drawing.Font</see> </para>
    '''    <para> La fuente con la que se ha escrito el texto. </para>
    '''    <para> Segun el tamaño de la fuente caben mas o menos caracteres en un espacio determinado </para>
    ''' </param>
    ''' <param name="formatoAplicado">
    '''    <para> Tipo:<see cref="System.Windows.Forms.TextFormatFlags">
    '''           Windows.Forms.TextFormatFlags</see></para>
    '''    <para> Especifica la información de diseño y de presentación de las cadenas de texto. </para>
    '''    <para> Esta enumeración tiene un atributo FlagsAttribute que 
    '''           permite una combinación bit a bit de los valores de miembro. </para>
    ''' </param>
    ''' <returns>
    '''    <para> Tipo:<see cref="System.String">String</see>   </para>
    '''    <para> Una cadena con el formato [AutoEllipsis] aplicado </para>
    ''' </returns>
    ''' <remarks>
    '''    <para>  Trunca una cadena de texto añadiendo el carácter puntos suspensivos (...), 
    '''            si el tamaño de la cadena de texto excede el tamaño máximo permitido
    '''    </para>
    '''    <para>  Tunca una cadena de texto Funciona de forma parecida a la 
    '''            propiedad [Label.AutoEllipsis] añadiendo el carácter de puntos suspensivos (...) 
    '''            normalmente a la derecha del texto, para indicar que el texto original 
    '''            excede del tamaño máximo marcado
    '''    </para>
    '''    <para>  La situación de los puntos suspensivos (...) está indicado por el valor 
    '''            de la enumeración [Windows.Forms.TextFormatFlags]
    '''    </para>
    '''    <example> Para saber mas
    '''       <code> http://www.codeproject.com/KB/vb/NewPathCompactPath.aspx </code>
    '''       <code> http://msdn.microsoft.com/es-es/library/system.windows.forms.textformatflags.aspx </code>
    '''       <code> http://msdn.microsoft.com/es-es/library/7sy6awsb.aspx </code>
    '''       <code> http://msdn.microsoft.com/es-es/library/system.windows.forms.label.autoellipsis.aspx </code>
    '''    </example>
    '''    <example> 
    ''' --------------------------------------------------- 
    '''  Ejemplo de uso
    ''' --------------------------------------------------- 
    ''' 'Escuchador del evento [TextChanged] de un TextBox
    ''' '--------------
    ''' Private Sub TextBox1_TextChanged( _
    '''             sender As System.Object, e As System.EventArgs) _
    '''             Handles TextBox1.TextChanged
    ''' 
    '''     TextBox1.Text = AutoElipsisTextBox.CompactString( _
    '''                     TextBox1.Text, _
    '''                     TextBox1.Width, _
    '''                     TextBox1.Font, _
    '''                     TextFormatFlags.EndEllipsis)
    ''' End Sub
    ''' --------------------------------------------------- 
    '''    </example>
    '''    <Historial>
    '''       <para> Creado el : 2011-12-03-17:11</para>
    '''       <para> Autor.: Joaquin Medina Serrano </para>
    '''       <para> Licencia.: Acogido a la lincia de The Code Project Open License (CPOL) 
    '''             <code>http://www.codeproject.com/info/cpol10.aspx </code>
    '''       </para>
    '''    </Historial>
    ''' </remarks>
    Private Shared Function CompactString( _
          ByVal cadenaOriginal As String, _
          ByVal anchuraMaxima As Integer,
          ByVal fuenteDelTexto As Drawing.Font,
          ByVal formatoAplicado As Windows.Forms.TextFormatFlags) _
         As String

        Dim cadenaCompactada As String = String.Copy(cadenaOriginal)

        Call TextRenderer.MeasureText( _
             cadenaCompactada, _
             fuenteDelTexto, _
             New Drawing.Size(anchuraMaxima, 0), _
             formatoAplicado Or TextFormatFlags.ModifyString)
        ' 
        Return cadenaCompactada

    End Function

#End Region


#Region "Propiedades"


    ''-------------------------------------------------------------------
    ''TextFormatFlags
    ''-------------------------------------------------------------------

    ''' <summary>
    '''    Especifica la información de diseño y de presentación de las cadenas de texto
    '''    se recomienda usar el valor [WordEllipsis]
    ''' </summary>
    Private _textFormatOpcion As Windows.Forms.TextFormatFlags = Windows.Forms.TextFormatFlags.WordEllipsis

    ''' <summary>
    '''    Especifica la información de diseño y de presentación de las cadenas de texto
    '''    se recomienda usar el valor [WordEllipsis]
    ''' </summary>
    ''' <value>
    '''    <para> Tipo:<see cref="System.Windows.Forms.TextFormatFlags">
    '''           Windows.Forms.TextFormatFlags</see></para>
    '''    <para> Especifica la información de diseño y de presentación de las cadenas de texto. </para>
    '''    <para> Esta enumeración tiene un atributo FlagsAttribute que 
    '''           permite una combinación bit a bit de los valores de miembro. </para>
    ''' </value>
    <Description("Especifica la información de diseño y de presentación de las cadenas de texto, se recomienda usar el valor [WordEllipsis]"), _
     Category("Z_DelControl")> _
    Public Property TextFormatOpcion() As Windows.Forms.TextFormatFlags
        Get
            Return _textFormatOpcion
        End Get
        Set(ByVal value As Windows.Forms.TextFormatFlags)
            _textFormatOpcion = value
        End Set
    End Property

    '--------------------------------------------
    Private Const TEXT_FORMAT_BANDERAS As Windows.Forms.TextFormatFlags = Windows.Forms.TextFormatFlags.Default
    Private Sub ResetTextFormatOpcion()
        TextFormatOpcion = TEXT_FORMAT_BANDERAS
    End Sub
    Private Function ShouldSerializeTextFormatOpcion() As Boolean
        If TextFormatOpcion.Equals(TEXT_FORMAT_BANDERAS) = True Then
            Return False
        Else
            Return True
        End If
    End Function



    '-------------------------------------------------------------------
    ' AutoElipsis
    '-------------------------------------------------------------------

    ''' <summary>
    '''   Obtiene o establece un valor que indica si el carácter de puntos suspensivos (...) 
    '''   aparece en el borde derecho del [TexBox], lo que indica que el texto  
    '''   se entiende más allá del espacio visible del control [TexBox]
    ''' </summary>
    Private _valorAutoElipsis As Boolean 'Inicializacion por defecto  = False

    ''' <summary>
    '''   Obtiene o establece un valor que indica si el carácter de puntos suspensivos (...) 
    '''   aparece en el borde derecho del [TexBox], lo que indica que el texto  
    '''   se entiende más allá del espacio visible del control [TexBox]
    ''' </summary>
    ''' <value>
    '''    <para> Tipo:<see cref="System.Boolean">Booelan</see></para>
    '''    <para> true si el texto de la etiqueta adicional se va a indicar mediante puntos suspensivos; de lo contrario, false.El valor predeterminado es false. </para>
    ''' </value>
    <Description(" Obtiene o establece un valor que indica si el carácter de puntos suspensivos (...)" & _
                 " aparece en el borde derecho del [TexBox], lo que indica que el texto" & _
                 " se entiende más allá del espacio visible del control [TexBox]"), _
     Category("Z_DelControl")> _
    Public Property AutoElipsis() As Boolean
        Get
            Return _valorAutoElipsis
        End Get
        Set(ByVal value As Boolean)
            _valorAutoElipsis = value
        End Set
    End Property

    '--------------------------------------------
    Private Const VALOR_AUTO_ELIPSIS As Boolean = False
    Private Sub ResetAutoElipsis()
        AutoElipsis = VALOR_AUTO_ELIPSIS
    End Sub
    Private Function ShouldSerializeAutoElipsis() As Boolean
        If AutoElipsis.Equals(VALOR_AUTO_ELIPSIS) = True Then
            Return False
        Else
            Return True
        End If
    End Function
    '--------------------------------------------


    ''' <summary>
    '''   Obtiene o establece el texto actual del TextBox.
    ''' </summary>
    ''' <value>
    '''  <para>Tipo: <see cref="System.String">System.String</see> </para>
    '''  <para>Texto que se muestra en el control.</para>
    '''</value>
    ''' <remarks>
    '''    Si la propiedad [AutoElipsis=True] quiere decir que en el cuadro de 
    '''    texto hay al final puntos suspensivos, con lo que sí quiero recuperar 
    '''    la información del cuadro de texto tengo que recuperar la información 
    '''    de la variable [_cadenaDelTextBox] que es la que guarda esa información,
    '''    si la propiedad no está activa [AutoElipsis=False] se devuelve 
    '''    directamente el valor de la propiedad [Text]
    '''</remarks>
    Public Overrides Property Text() As String
        Get
            ' Ver el comentario puesto en <remarks>
            If AutoElipsis = True Then
                Return Me._cadenaDelTextBox
            Else
                Return MyBase.Text
            End If
        End Get
        Set(ByVal value As String)
            MyBase.Text = value
        End Set
    End Property


#End Region


#Region "Eventos"

    ' Me.GotFocus '  Guarda el valor de la propiedad [Text], para poder recuperar el valor original introducido
    ' LostFocus   '  Al abandonar el control se guarda el valor y se muestra el valor formateado
    ' MouseHover  '  Se muestra (en un ToolTip) todo el contenido del TextBox al pasar el cursor por encima
    ' MouseLeave  '  Se borra el  ToolTip




    ''' <summary>
    '''   Guarda el valor de la propiedad [Text], para poder recuperar el valor original introducido
    ''' </summary>
    ''' <remarks>
    '''   Hay que tener en cuenta que al poner los puntos suspensivos en el control,
    '''   se pierde el texto introducido, y de esta forma lo conservo y puedo reponerlo cuando haga falta
    '''</remarks>
    Private _cadenaDelTextBox As String = String.Empty

    '----------------------------------------------------------
    'Al entrar en el control, se muestra el valor (si existe)
    ' solo funciona si Autoelipsis=true
    '----------------------------------------------------------
    ' Bug [2011-12-04]
    ' Problema: 
    '   En este código no estaba la instrucción [If] y se cargaba el  
    '   valor interno en la propiedad [Text] del control.
    '   Cuando a través del diseñador se añade algún valor al cuadro de texto,  
    '   la primera vez que se entre en este evento, tendremos un valor en  
    '   el cuadro de texto pero ninguno en la variable que conserva el valor, 
    '    y el valor del diseñador se perdía.
    ' Solución adoptada:  
    '   Incluyo la instrucción [If], que figura actualmente
    '   Pregunto a ver si existe algún valor en la variable interna[_cadenaDelTextBox],  
    '   y si no existe no hago nada, con lo que se conserva el posible  
    '   valor inicial que pueda tener el cuadro de texto en la propiedad [Text]
    '----------------------------------------------------------
    Private Sub TextBoxNumerico_GotFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.GotFocus
        ' Si no se realiza [AutoElipsis] ni siquiera entrar aqui
        If AutoElipsis = False Then Exit Sub
        '
        If String.IsNullOrWhiteSpace(Me._cadenaDelTextBox) = False Then
            Me.Text = Me._cadenaDelTextBox
        End If
    End Sub


    '----------------------------------------------------------
    ' al abandonar el control
    ' se guarda el valor y se muestra el valor formateado
    ' solo funciona si Autoelipsis=true
    '----------------------------------------------------------
    Private Sub TextBoxNumerico_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LostFocus
        ' Si no se realiza [AutoElipsis] ni siquiera entrar aqui
        If AutoElipsis = False Then Exit Sub

        ' el fomrato numerico general con dos decimales
        'Me.Text = String.Format("{0:N2}", Me.ZValue)
        ' formato moneda
        Me._cadenaDelTextBox = Me.Text

        ' autoelipsis
        Me.Text = CompactString(Me.Text, Me.Width, Me.Font, TextFormatFlags)
    End Sub




    '-----------------------------------------------------------------------
    ' en esta parte del codigo, se muestra todo el contenido del TextBox al pasar el cursor por encima
    ' solo funciona si Autoelipsis=true
    Private _toolTipInterno As ToolTip ' Inicializacion por defecto = Nothing
    Private Sub TextBoxAutoElipsis_MouseHover(sender As Object, e As System.EventArgs) Handles Me.MouseHover
        ' Si no se realiza [AutoElipsis] ni siquiera entrar aqui
        If AutoElipsis = False Then Exit Sub
        '-----------------------------------
        ' instanciacion diferida ( si no se usa no se instancia)
        If _toolTipInterno Is Nothing Then
            _toolTipInterno = New ToolTip
        End If
        '-------
        _toolTipInterno.SetToolTip(Me, Me._cadenaDelTextBox)
    End Sub

    'MouseLeave ' 'se borra el  ToolTip
    Private Sub TextBoxAutoElipsis_MouseLeave(sender As Object, e As System.EventArgs) Handles Me.MouseLeave
        ' Si no se realiza [AutoElipsis] ni siquiera entrar aqui
        If AutoElipsis = False Then Exit Sub
        '-----------------------------------
        ' instanciacion diferida ( si no se usa no se instancia)
        If _toolTipInterno Is Nothing Then
            _toolTipInterno = New ToolTip
        End If
        '-------
        _toolTipInterno.SetToolTip(Me, String.Empty)
    End Sub

#End Region

#End Region

End Class
